/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmView::init()
{
	glv = 0;
	glv_layout = new QHBoxLayout( frmGLV);
	mdl = 0;
	(statusBar())->hide();
	
	// Create the basic view popup menu. The firs menu is the main
	// menu, and all others are sub-menus.
	QPopupMenu *mnu_main = new QPopupMenu();
	QPopupMenu *mnu_camera = new QPopupMenu();
	mnu_csg = new QPopupMenu();
	mnu_file = new QPopupMenu();
	mnu_model = new QPopupMenu();
	mnu_edit = new QPopupMenu();
	mnu_tools = new QPopupMenu();
	mnu_view = new QPopupMenu();
	mnu_group = new QPopupMenu();
	mnu_bone = new QPopupMenu();
	mnu_texture = new QPopupMenu();
	
	// Setting up the main menu.
	mnu_main->insertItem( "File", mnu_file);
	mnu_main->insertItem( "Edit", mnu_edit);
	mnu_main->insertItem( "View", mnu_view);
	mnu_main->insertItem( "Camera", mnu_camera);
	mnu_main->insertItem( "CSG", mnu_csg);
	mnu_main->insertItem( "Model", mnu_model);
	mnu_main->insertItem( "Bone", mnu_bone);
	mnu_main->insertItem( "Group", mnu_group);
	mnu_main->insertItem( "Texture", mnu_texture);
	mnu_main->insertItem( "Tools", mnu_tools);
	
	// Setting up the file menu
	mnu_file->insertItem( "&New", this,
		SLOT( on_new_model()));
	mnu_file->insertItem( "&Open...", this,
		SLOT( on_open_model()));
	mnu_file->insertSeparator();
	mnu_file->insertItem( "&Close", this,
		SLOT( on_close_model()));
	mnu_file->insertSeparator();
	mnu_file->insertItem( "&Save", this,
		SLOT( on_save_model()));
	mnu_file->insertItem( "Save &As...", this,
		SLOT( on_save_as_model()));

	// Setting up the edit menu.
	mnu_edit->insertItem( "Mirror selection", this,
		SLOT( on_edit_mirror_selection()));
	mnu_edit->insertItem( "Flip selection", this,
		SLOT( on_edit_flip_selection()));
	mnu_edit->insertSeparator();
	mnu_edit->insertItem( "Invert selected mesh", this,
		SLOT( on_edit_invert_selected_mesh()));
	mnu_edit->insertSeparator();
	mnu_edit->insertItem( "Duplicate selected vertices", this,
		SLOT( on_edit_duplicate_vertices()));
	mnu_edit->insertItem( "Duplicate selected mesh", this,
		SLOT( on_edit_duplicate_mesh()));
	
	
	// Setting up the camera menu.
	mnu_camera->insertItem( "Move to Origin", this,
		SLOT( on_camera_move_to_origin()));
	mnu_camera->insertItem( "Reset", this,
		SLOT( on_camera_reset()));
	mnu_camera->insertSeparator();
	mnu_camera->insertItem( "Set Front View", this,
		SLOT( on_camera_set_front_view()));
	mnu_camera->insertItem( "Set Side View", this,
		SLOT( on_camera_set_side_view()));
	mnu_camera->insertItem( "Set Top View", this,
		SLOT( on_camera_set_top_view()));

	// Setting up the CSG menu.
	mnu_csg->insertItem( "Set active brush", this,
		SLOT( on_csg_set_active_brush()));
	mnu_csg->insertItem( "Reset brush", this,
		SLOT( on_csg_reset_brush()));
	mnu_csg->insertSeparator();
	mnu_csg->insertItem( "&Union brush", this,
		SLOT( on_csg_union()));
	mnu_csg->insertItem( "&Difference brush", this,
		SLOT( on_csg_difference()));
	mnu_csg->insertItem( "&Subtraction brush", this,
		SLOT( on_csg_subtraction()));

	// Setup the model menu.
	mnu_model->insertItem( "Display model statistics", this,
		SLOT( on_model_display_statistics()));
	mnu_model->insertSeparator();
	mnu_model->insertItem( "Generate flat shaded model", this,
		SLOT( on_model_gen_flat_shade()));
	mnu_model->insertItem( "Generate smooth shaded model", this,
		SLOT( on_model_gen_smooth_shade()));
	mnu_model->insertItem( "Compile texture data", this,
		SLOT( on_model_compile_texture_data()));
	mnu_model->insertItem( "Compile alpha faces", this,
		SLOT( on_model_compile_alpha_faces()));
	mnu_model->insertItem( "Reload all textures", this,
		SLOT( on_model_reload_textures()));
	mnu_model->insertSeparator();
	mnu_model->insertItem( "Delete all skeleton frames", this,
		SLOT( on_model_delete_all_skel_frames()));
	mnu_model->insertItem( "Delete all animation sequences", this,
		SLOT( on_model_delete_all_animations()));

	// Setting up the bone menu.
	mnu_bone->insertItem( "&Reset skeleton", this,
		SLOT( on_bone_reset_skeleton()));
	mnu_bone->insertSeparator();
	mnu_bone->insertItem( "Set vertex weights", this,
		SLOT( on_set_vertex_weights()));
	mnu_bone->insertSeparator();
	mnu_bone->insertItem( "&Bind verts to selected bone", this,
		SLOT( on_bone_bind_to_selected()));
	mnu_bone->insertItem( "&Unbind selected vertices", this,
		SLOT( on_bone_make_boneless()));
	mnu_bone->insertItem( "&Bind brush to selected bone", this,
		SLOT( on_bone_bind_brush()));
	mnu_bone->insertItem( "&Unbind brush from bone", this,
		SLOT( on_bone_unbind_brush()));
	mnu_bone->insertSeparator();
	mnu_bone->insertItem( "Set bone &name", this,
		SLOT( on_bone_set_name()));
	mnu_bone->insertItem( "&Swap bone pivot/rotation joint", this,
		SLOT( on_bone_swap_rotation_joint()));
	mnu_bone->insertItem( "Re&position bone", this,
		SLOT( on_bone_reposition_bone()));
	mnu_bone->insertSeparator();
	mnu_bone->insertItem( "Unbind (free) slave bones", this,
		SLOT( on_bone_unbind_slave_bones()));
	mnu_bone->insertItem( "Unbind (free) selected bone", this,
		SLOT( on_bone_unbind_selected_bone()));
	mnu_bone->insertSeparator();
	mnu_bone->insertItem( "Unmount selected bone", this,
		SLOT( on_bone_unmount_selected_bone()));

	// Setting up the group menu.
	mnu_group->insertItem( "Bind verts to active group", this,
		SLOT( on_group_add_to_selected()));
	mnu_group->insertItem( "Make verts \"groupless\"", this,
		SLOT( on_group_make_groupless()));
	mnu_group->insertSeparator();
	mnu_group->insertItem( "Bind brush to active group", this,
		SLOT( on_group_bind_brush()));
	mnu_group->insertItem( "Make brush \"groupless\"", this,
		SLOT( on_group_make_brush_groupless()));
	mnu_group->insertSeparator();
	mnu_group->insertItem( "Bind visible faces to active group", this,
		SLOT( on_group_bind_visible_faces()));
	
	
	// Setting up the tools menu.
	mnu_tools->insertItem( "Show Grid", this,
		SLOT( on_tools_show_grid()), 0, 0);
	mnu_tools->insertItem( "Snap to grid", this,
		SLOT( on_tools_snap_to_grid()), 0, 3);
	mnu_tools->insertItem( "Show Cross Hair", this,
		SLOT( on_tools_show_cross_hair()), 0, 1);
	mnu_tools->insertItem( "Show Rulers", this,
		SLOT( on_tools_show_rulers()), 0, 2);
	
	// Setting up the texture menu.
	mnu_texture->insertItem( "Generate planar map...", this,
		SLOT( on_texture_gen_planar_map()));

	// Setting up the view menu.
	mnu_view->insertItem( "Group window", this,
		SLOT( on_view_show_group_window()));
	mnu_view->insertItem( "Texture edit window", this,
		SLOT( on_view_show_texture_window()));
	mnu_view->insertItem( "Skeleton Frame window", this,
		SLOT( on_view_show_skeleton_frame_window()));
	mnu_view->insertItem( "Sequence Window", this,
		SLOT( on_view_show_sequence_window()));
	mnu_view->insertSeparator();
	mnu_view->insertItem( "Is editable", this,
		SLOT( on_view_toggle_editable()), 0, 2);
	mnu_view->insertItem( "Wireframe", this,
		SLOT( on_view_toggle_wireframe()), 0, 0);
	mnu_view->insertItem( "Lighting", this,
		SLOT( on_view_toggle_lighting()), 0, 1);
	mnu_view->insertItem( "Texture", this,
		SLOT( on_view_toggle_texture()), 0, 3);
	mnu_view->insertSeparator();
	mnu_view->insertItem( "Spawn view", this,
		SLOT( on_view_spawn_view()));
	mnu_view->insertItem( "Create four view", this,
		SLOT( on_view_create_four_view()));
	mnu_view->insertSeparator();
	mnu_view->insertItem( "Cascade", this,
		SLOT( on_view_cascade()));
	mnu_view->insertItem( "Tile", this,
		SLOT( on_view_tile()));
	
	// XXX: "mnu_main" MUST ALWAYS be the first menu in the list.
	m_menu.push_back( mnu_main);
	m_menu.push_back( mnu_file);
	m_menu.push_back( mnu_edit);
	m_menu.push_back( mnu_view);
	m_menu.push_back( mnu_camera);
	m_menu.push_back( mnu_csg);
	m_menu.push_back( mnu_model);
	m_menu.push_back( mnu_bone);
	m_menu.push_back( mnu_group);
	m_menu.push_back( mnu_tools);
	m_menu.push_back( mnu_texture);

	//setFocusPolicy( QWidget::StrongFocus);
	
}

void frmView::destroy()
{
	if( glv) delete glv;
	if( glv_layout) delete glv_layout;
	while( !(m_menu.empty())) {
		if( m_menu[ m_menu.size() - 1])
			delete (m_menu[m_menu.size() - 1]);
		m_menu.erase( m_menu.begin() + (m_menu.size() - 1));
	}
	
	// Destroy complete if there is no model associated with this view.
	if( !mdl) {
		//std::cerr << (void *)this << ", modeless view destroyed\n";
		return;
	}
	
	//std::cerr << (void *)this << ", model view being destroyed\n";
	
	// NOTE: Release this window from the working model
	// before destroying it.
	mdl->destroy_view( this);
	
	// If the last view window is being destroyed, then delete
	// the model.
	if( (mdl->view.empty())) {
		krn_delete_model( mdl);
		//std::cerr << (void *)this <<
		//", last model view being destroyed\n";
	}
}


void frmView::create_glview( QGLWidget *glw)
{
	glv = new GLView( frmGLV, 0, glw);
	glv_layout->addWidget( glv);
	glv->setMouseTracking( true);
	//glv->setFocusPolicy( QWidget::StrongFocus);
}


void frmView::on_camera_move_to_origin()
{
	glv->vmat.camT.loadIdentity();
	glv->vmat.icamT.loadIdentity();
	glv->vmat.update();
	glv->updateGL();
}

void frmView::on_camera_reset()
{
	glv->vmat.reset();
	glv->updateGL();
}

void frmView::on_camera_set_front_view()
{
	glv->vmat.camT.loadIdentity();
	glv->vmat.icamT.loadIdentity();
	glv->vmat.camR.loadIdentity();
	glv->vmat.icamR.loadIdentity();
	glv->vmat.update();
	glv->updateGL();
}

void frmView::on_camera_set_side_view()
{
	glv->vmat.camT.loadIdentity();
	glv->vmat.icamT.loadIdentity();
	glv->vmat.camR.loadIdentity();
	glv->vmat.icamR.loadIdentity();
	glv->vmat.rotate( RG_DEGTORAD( 90.0f), rgVector( 0, 1, 0));
	glv->vmat.update();
	glv->updateGL();
}

void frmView::on_camera_set_top_view()
{
	glv->vmat.camT.loadIdentity();
	glv->vmat.icamT.loadIdentity();
	glv->vmat.camR.loadIdentity();
	glv->vmat.icamR.loadIdentity();
	glv->vmat.rotate( RG_DEGTORAD( 90.0f), rgVector( 1, 0, 0));
	glv->vmat.update();
	glv->updateGL();
}

void frmView::on_tools_show_grid()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.show_grid = !(vd.show_grid);
	mnu_tools->setItemChecked( 0, vd.show_grid);
}

void frmView::on_tools_show_cross_hair()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.show_cross_hair = !(vd.show_cross_hair);
	mnu_tools->setItemChecked( 1, vd.show_cross_hair);
}

void frmView::on_tools_show_rulers()
{
	
}


void frmView::on_view_toggle_wireframe()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.use_wireframe = !(vd.use_wireframe);
	mnu_view->setItemChecked( 0, vd.use_wireframe);
}

void frmView::on_view_toggle_lighting()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.use_lighting = !(vd.use_lighting);
	mnu_view->setItemChecked( 1, vd.use_lighting);
}


void frmView::init_popup_menus()
{
	if( !glv) return;
	if( !glv->edata) return;
	ViewData &vd = *((ViewData *)glv->edata);
	
	// Initialize the "tools" sub-menu.
	mnu_tools->setItemChecked( 0, vd.show_grid);
	mnu_tools->setItemChecked( 1, vd.show_cross_hair);
	mnu_tools->setItemChecked( 3, mdl->snap_to_grid);
	
	// Initialize the "view" sub-menu.
	mnu_view->setItemChecked( 0, vd.use_wireframe);
	mnu_view->setItemChecked( 2, vd.edit_window);
}






void frmView::on_new_model()
{
	krn_call_new_model();
}

void frmView::on_open_model()
{
	krn_call_open_model();
}

void frmView::on_close_model()
{
	// NOTE: Release this window from the working model
	// before destroying all views (so this view is destroyed while
	// still in this member function).
	//mdl->destroy_view( this);
	
	// Destroy all other view windows. "mdl" itself will be deleted
	// when the last of the view windows is destroyed (that is,
	// "mdl" will be destroyed before "delete_all_view_windows"
	// returns).
	
	// NOTE: "delete_all_view_windows" does not really delete the
	//	windows, but does send a close request to each view.
	//	The view's themselves will handle their own destruction
	//	and the last view will delete the model.
	mdl->delete_all_view_windows();
	
	//mdl = 0;
	
	// Mark this view for destruction.
	//emit close();
}

void frmView::on_save_model()
{
	// Request a filename if non was specified.
	QString s;
	if( mdl->fname.isEmpty()) {
		if( !hlp_request_save_name( s)) return;
	} else s = mdl->fname;
	
	hlp_do_save( s);
}

void frmView::on_save_as_model()
{
	QString s;
	if( hlp_request_save_name( s)) hlp_do_save( s);
}


void frmView::on_view_spawn_view()
{
	if( !mdl) return;
	frmView *v = krn_create_model_view_window( *mdl);
	if( v) v->show();
}


void frmView::on_view_cascade()
{
	krn_cascade_windows();
}

void frmView::on_view_tile()
{
	krn_tile_windows();
}


bool frmView::hlp_request_save_name( QString &s)
{
	s = QFileDialog::getSaveFileName(
		QString::null,
		"3DRom Files (*.3dr)",
		this,
		"save file dialog"
		"Choose a file");
	if( s.isEmpty()) return false;
	return true;
}


void frmView::hlp_do_save( QString &s)
{
	// Save the 3DRom model now.
	const int err = mdl->mdl.save( s.latin1());
	if( err) {
		QString tmp;
		tmp.sprintf( "Could not save 3DRom file (error %d).",
			     err);
		QMessageBox::critical( this, "3DRomED", tmp,
				       QMessageBox::Ok,
				       QMessageBox::NoButton,
				       QMessageBox::NoButton);
		return;
	}
	mdl->fname = s;
	mdl->set_caption_for_all_views( s.latin1());
	mdl->modified = false;
}


void frmView::closeEvent( QCloseEvent *e )
{
	// If there is no model, or the model has not been modified, or
	// this is not the last window, then this window can be closed.
	if( !mdl || (!(mdl->modified)) || (mdl->view.size() > 1)) {
		e->accept();
		return;
	}

	// This is the last model view window and it is being closed.
	// Therefore the model must be saved before closing this window.
	if( !(save_model_before_destroy())) {
		e->ignore();
		return;
	}

	// This window can now be closed safely.
	e->accept();
}


bool frmView::save_model_before_destroy()
{
	if( !mdl) return true;
	if( !(mdl->modified)) return true;

	QString tmp;
	if( !(mdl->fname.isEmpty()))
		tmp.sprintf( "Save changes to \"%s\"?", mdl->fname.latin1());
	else tmp.sprintf( "Save changes to \"%s\"?", (caption()).latin1());

	const int result =  QMessageBox::warning( this, "3DRomED", tmp,
		QMessageBox::Yes, QMessageBox::No, QMessageBox::Cancel);
	switch( result) {
	// Yes: Prompt user to save the model first.
	case QMessageBox::Yes:
		// Do not destroy the model if the user could not save the
		// model.
		on_save_model();
		if( mdl->modified) return false;
		break;

	// No: Model can be destroyed safely (unsaved changes will be lost)
	case QMessageBox::No:
		mdl->modified = false;	// Mark as safe to destroy
		break;

	// Cancel: Do not destroy the model (do nothing)
	case QMessageBox::Cancel: return false;
	}

	return true;
}


void frmView::on_view_show_group_window()
{
	mdl->frmGrp->hide();
	mdl->frmGrp->show();
}


void frmView::on_group_add_to_selected()
{
	if( !(mdl->sel_verticies)) return;
	const int gid = mdl->frmGrp->lstGroup->index(
		mdl->frmGrp->lstGroup->selectedItem());
	if( gid < 0) return;
	mdl->mdl.set_vertex_gid( mdl->sel_verticies,
		mdl->sel_vertices_count, gid);
}

void frmView::on_group_make_groupless()
{
	if( !(mdl->sel_vertices)) return;
	mdl->mdl.set_vertex_gid( mdl->sel_verticies,
		mdl->sel_vertices_count, -1);
}


void frmView::on_bone_reset_skeleton()
{
	mdl->mdl.skel.init_skel_frame( mdl->mdl.skel.skout);
	mdl->mdl.transform_skel_frame();
	mdl->sel_bone = -1;
	mdl->do_bone_bind = false;
	mdl->update_all_views();
}

void frmView::on_bone_bind_to_selected()
{
	mdl->mdl.bind_vertices_to_bone(
		mdl->sel_vertices,
		mdl->sel_vertices_count,
		mdl->sel_bone);
}

void frmView::on_bone_make_boneless()
{
	mdl->mdl.unbind_vertices(
		mdl->sel_vertices,
		mdl->sel_vertices_count);
}


void frmView::on_edit_duplicate_vertices()
{
	if( !(mdl->sel_vertices)) return;
	const int tmp = int( mdl->mdl.v.size());
	mdl->mdl.duplicate_vertices( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->mdl.transform_skel_frame();
	for( int i = 0; i < (mdl->sel_vertices_count); i++)
		mdl->sel_vertices[i] = tmp + i;
	mdl->update_all_views();
}


void frmView::on_edit_duplicate_mesh()
{
	if( !(mdl->sel_vertices)) return;
	const int tmp = int( mdl->mdl.v.size());
	mdl->mdl.duplicate_mesh( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->mdl.transform_skel_frame();
	for( int i = 0; i < (mdl->sel_vertices_count); i++)
		mdl->sel_vertices[i] = tmp + i;
	mdl->update_all_views();
}


void frmView::on_bone_unbind_selected_bone()
{
	if( mdl->sel_bone < 0) return;
	mdl->mdl.skel.unbind_bone( mdl->sel_bone);
}


void frmView::on_bone_unbind_slave_bones()
{
	std::cerr << "unbind slave bones!!!\n";
}


void frmView::on_bone_swap_rotation_joint()
{
	if( mdl->sel_bone < 0) return;
	mdl->mdl.swap_pivot_joint( mdl->sel_bone);
}


void frmView::on_bone_reposition_bone()
{
	const int bid = mdl->sel_bone;
	if( bid < 0) return;
	sk3DRomBone &b = mdl->mdl.skel.b[bid];
	if( b.mid >= 0) {
		QString s, sname;
		if( '\0' == b.bname[0]) sname.sprintf( "%d", bid);
		else sname.sprintf( "\"%s\"", b.bname);
		s.sprintf(
			"Bone %s has a master controlling it.\nYou must "
			"unbind it from the master to reposition this "
			"bone.",
			sname.latin1());
		QMessageBox::information( this, "Cannot Reposition Bone", s);
		return;
	}
	if( !(b.link.empty())) {
		QString s, sname;
		if( '\0' == b.bname[0]) sname.sprintf( "%d", bid);
		else sname.sprintf( "\"%s\"", b.bname);
		s.sprintf(
			"Bone %s has bound slaves.\nYou must "
			"unbind all slaves to reposition this bone.",
			sname.latin1());
		QMessageBox::information( this, "Cannot Reposition Bone", s);
		return;
	}
	mdl->mdl.reposition_bone( bid, mdl->bone_build_v[0],
		mdl->bone_build_v[1]);
	mdl->mdl.transform_skel_frame();
}


void frmView::on_bone_set_name()
{
	const int bid = mdl->sel_bone;
	if( bid < 0) return;
	sk3DRomBone &b = mdl->mdl.skel.b[bid];
	bool ok;
	QString text = QInputDialog::getText(
		"Set bone name", "Enter name:", QLineEdit::Normal,
		b.bname, &ok, this);
	if( ok) strncpy( b.bname, text.latin1(), SK3DROM_BONE_NAME_LEN - 1);
	mdl->frmSeq->on_populate_target_bone_list();
}


void frmView::on_bone_unmount_selected_bone()
{
	if( mdl->sel_bone < 0) return;
	mdl->mdl.skel.unmount_bone( mdl->sel_bone,
		mdl->mdl.skel.skout);
}


void frmView::on_edit_mirror_selection()
{
	if( !(mdl->sel_vertices)) return;
	mdl->mdl.mirror_tv_vertices( mdl->sel_vertices,
		mdl->sel_vertices_count,
		mdl->get_selection_box_center(),
		glv->view_normal(),
		glv->side_vector());
	mdl->mdl.set_vertex_from_tv( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->mdl.invert_mesh( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->update_all_views();
}


void frmView::on_edit_flip_selection()
{
	if( !(mdl->sel_vertices)) return;
	mdl->mdl.mirror_tv_vertices( mdl->sel_vertices,
		mdl->sel_vertices_count,
		mdl->get_selection_box_center(),
		glv->view_normal(),
		glv->up_vector());
	mdl->mdl.set_vertex_from_tv( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->mdl.invert_mesh( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->update_all_views();
}


void frmView::on_edit_invert_selected_mesh()
{
	if( !(mdl->sel_vertices)) return;
	mdl->mdl.invert_mesh( mdl->sel_vertices,
		mdl->sel_vertices_count);
	mdl->update_all_views();
}


void frmView::on_model_display_statistics()
{
	std::cout << "Model Statistics:"
		<< "\n\tVertex Count: " << mdl->mdl.v.size()
		<< "\n\tFace Count: " << mdl->mdl.f.size()
		<< "\n\tBone Count: " << mdl->mdl.skel.b.size()
		<< "\n\tSkeleton Frames: " << mdl->mdl.skel.sf.size()
		<< "\n\n";
}


void frmView::on_view_toggle_editable()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.edit_window = !(vd.edit_window);
	mnu_view->setItemChecked( 2, vd.edit_window);
}


void frmView::on_model_gen_flat_shade()
{
	mdl->mdl.gen_flat_shade_normals();
}


void frmView::on_model_gen_smooth_shade()
{
	mdl->mdl.gen_smooth_shade_normals();
}


void frmView::on_model_delete_all_skel_frames()
{
	mdl->mdl.delete_all_skeleton_frames();
}


void frmView::on_view_show_texture_window()
{
	mdl->frmTex->hide();
	mdl->frmTex->show();
}


void frmView::on_model_compile_texture_data()
{
	mdl->mdl.compile_texture_data();
	mdl->update_all_views();
}


void frmView::on_view_toggle_texture()
{
	ViewData &vd = *((ViewData *)glv->edata);
	vd.use_texture = !(vd.use_texture);
	mnu_view->setItemChecked(3, vd.use_texture);
}


void frmView::on_model_reload_textures()
{
	// FIXME: The directories to load from should be user selectable.
	const char *tmp[] = {
		".",
		"../media",
		"../media/bmp",
		"../media/3dr"
	};
	mdl->mdl.load_textures( tmp, sizeof( tmp) / sizeof( const char *));
	mdl->update_all_views();
}


void frmView::on_model_delete_all_animations()
{
	const int result = QMessageBox::warning( this,
		"Delete all Sequences",
		"Do you really want to delete all sequences?",
		QMessageBox::Yes, QMessageBox::No);
	switch( result) {
	case QMessageBox::Yes:
		mdl->mdl.delete_all_sequences();
		break;
	}
}


void frmView::on_view_show_skeleton_frame_window()
{
	mdl->frmSkel->hide();
	mdl->frmSkel->show();
}


void frmView::on_view_show_sequence_window()
{
	mdl->frmSeq->hide();
	mdl->frmSeq->show();
}


void frmView::on_csg_set_active_brush()
{
	std::cerr << "CSG: Set active brush\n";
}

void frmView::on_csg_reset_brush()
{
	std::cerr << "CSG: Reset brush\n";
}

void frmView::on_csg_union()
{
	std::cerr << "CSG: Union\n";
}

void frmView::on_csg_difference()
{
	std::cerr << "CSG: Difference\n";
}

void frmView::on_csg_subtraction()
{
	std::cerr << "CSG: Subtraction\n";
}


void frmView::on_view_create_four_view()
{
	mdl->create_four_view();
}


void frmView::on_bone_bind_brush()
{
	mdl->mdl.bind_brush_to_bone( mdl->mdl.m_brush_cursor, mdl->sel_bone);
}

void frmView::on_bone_unbind_brush()
{
	mdl->mdl.unbind_brush( mdl->mdl.m_brush_cursor);
}


void frmView::on_group_bind_brush()
{
	if( !(mdl->mdl.m_brush_cursor)) return;
	mdl->mdl.m_brush_cursor->set_group_id( mdl->frmGrp->lstGroup->index(
		mdl->frmGrp->lstGroup->selectedItem()));
	mdl->update_all_views();
}

void frmView::on_group_make_brush_groupless()
{
	if( !(mdl->mdl.m_brush_cursor)) return;
	mdl->mdl.m_brush_cursor->set_group_id( -1);
	mdl->update_all_views();
}


void frmView::on_texture_gen_planar_map()
{
	QString s;
	QStringList lst;
	for( int i = 0; i < int( mdl->frmTex->lstPage->count()); i++)
		lst << (s.setNum( i) + ": " + mdl->frmTex->lstPage->text( i));
	bool ok;
	QString res = QInputDialog::getItem( "Generate Planar Map",
		"Select a page:", lst, 0, TRUE, &ok, this);
	if( res.isEmpty()) return;
	if ( ok ) {
		for( int i = 0; i < int( mdl->frmTex->lstPage->count()); i++) {
			if( res == (s.setNum( i) + ": " +
				mdl->frmTex->lstPage->text( i))) {
				mdl->mdl.gen_planar_map( true,
					glv->vmat.icamR, i);
				return;
			}
		}
		mdl->frmTex->on_add_page();
		sk3DRomTexturePage *p = mdl->mdl.edit_page(
			mdl->frmTex->lstPage->count() - 1);
		p->set_page_name( res);
		mdl->frmTex->populate_page_list();
		mdl->mdl.gen_planar_map( true, glv->vmat.icamR,
			mdl->frmTex->lstPage->count() - 1);
	}
}


void frmView::on_model_compile_alpha_faces()
{
	mdl->mdl.compile_alpha_faces();
	mdl->update_all_views();
}


void frmView::on_group_bind_visible_faces()
{
	mdl->mdl.set_group_of_visible_faces(
		mdl->frmGrp->lstGroup->index(
			mdl->frmGrp->lstGroup->selectedItem()));
	mdl->update_all_views();
}


void frmView::on_set_vertex_weights()
{
	if( mdl->sel_vertices_count <= 0) return;
	bool ok;
	double res = QInputDialog::getDouble(
		"Set vertex weights", "Enter weight:", 1.0, -1.0,
		1.0, 6, &ok, this);
	if( !ok) return;
	for( int i = 0; i < mdl->sel_vertices_count; i++)
		mdl->mdl.v[ mdl->sel_vertices[i]].weight = res;
	mdl->update_all_views();
}


void frmView::on_tools_snap_to_grid()
{
	mdl->snap_to_grid = !(mdl->snap_to_grid);
	mnu_tools->setItemChecked( 3, mdl->snap_to_grid);
}
